import { useEffect, useState } from "react";
import CountDownProgressbar from "./CountDownProgressBar";

export default function Timer({second,timerOn,finish}) {
    const [time, setTime] = useState(second);
    const [percentage,setPercentage] = useState(100);
    useEffect(() => {
        if (timerOn) {
            const intervalId = setInterval(() => {
                setTime((prevTime) => prevTime - 1);
                setPercentage(Math.floor((time * 100) / second));
                if (time == 0) {
                    finish();
                }
            }, 1000);
            return () => clearInterval(intervalId);
        }
    }, [timerOn, time]);

    return (
        <>
                <CountDownProgressbar  value={time} percentage={percentage} maxValue={second} minValue={0}/>    
        </>
    );
}