
import { SubmitButton, TextInput } from "daraman-nextjs-bootstrap-form-elements";
import { validationAll } from "daraman-nextjs-validation-inputs";
import { signIn } from "next-auth/react";
import { useRouter } from "next/navigation";
import { useContext, useState } from "react";
import { UserContext } from "../../contexts/UserContext";

const GetPassword = ({step,setStep}) =>{

    const [isLoading,setIsLoading] = useState(false);

    const {user,setUser} = useContext(UserContext);

    const router = useRouter();
    
    const handleChange = (e) =>{
        const {name,value} = e.target;
        setUser((prev)=>({
            ...prev,
            [name]:value
        }))
    }

    const submit = async () =>{
        setIsLoading(true);
        setUser((prev) =>({
            ...prev,
            ['redirect']:false
        }))
        return await validationAll().then(async res=>{
           const login = await signIn("credentials",user);
           if (login.ok) {
            //console.log(user.callbackAddr);
            return router.push(user.callbackAddr);
           }else{
            // Toaster(login.error,'default',{position:'bottom-right'});
            setIsLoading(false);
            return false;
           }
        }).catch(e =>{
            // Toaster("لطفا خطا های مربوط به فرم را برطرف کنید");
            return false;
        })
    }
    const changeStepTo = (stepId) =>{
        setStep(stepId);
    }

    return (
        <div className="login-form steps active" id="step-2">
                        <div className="detail">
                            <h2>خوش آمدید !</h2>
                            
                            <p>رمز عبور خود را برای ورود به پنل کاربری وارد نمایید.</p>
                        </div>
                        
                        <TextInput type="password"
                            name="Password"
                            val={user.Password}
                            iconClass="bi bi-key"
                            validationRule="required"
                            onChange={handleChange}
                            
                        />
                        

                        <div className="quick-access my-1 mt-3">
                            <div className="link" data-step="#step-3" onClick={() => changeStepTo(2)}>
                                <span>ورود با کد یکبار مصرف</span>
                            </div>
                            
                        </div>
                        <div className="submit-form">
                        <SubmitButton text={'ورود '}  isDisabled={isLoading} isLoading={isLoading} callback={submit} />
                        </div>
                        
                        
                    </div>
    )
}

export default GetPassword;