'use client'




import { sendVerification } from "./functions";
import { useContext, useRef, useState } from "react";

import { useEffect } from "react";
import { signIn } from "next-auth/react";
import { useRouter } from "next/navigation";
import { UserContext } from "../../contexts/UserContext";
import { validationAll } from "daraman-nextjs-validation-inputs";
import { OtpInput, SubmitButton } from "daraman-nextjs-bootstrap-form-elements";
import Timer from "../CountDownProgress/Timer";

const Verification = ({step,setStep}) =>{
    const {user,setUser} = useContext(UserContext);
    const [timerActive,setTimerActive] = useState(true);
    const [isLoading,setIsLoading] = useState(false);
    const [sendVerificationCode,setSendVerificationCode] = useState(false);
    const [verCode,setVerCode] = useState(false); 
    const router = useRouter();

    const resendCode = async () =>{
        //setMultiInputActive(false);
        return await sendVerification(user).then(res =>{
            setTimerActive(true);
            setUser((prev) => ({
                ...prev,
                ['verification']: '',
                ['authenticationToken']:res.dt_Data[0].authenticationToken
            }));
            return true;
        });
        
    }
    const verifycode = useRef('')

    const setMultiValue = (val) => {
        verifycode.current = val;
        setVerCode(val);
    }

    const [resetMultiInput , setResetMultiInput] = useState(false);


    const [timer,setTimer] = useState(0);
    const finishTimer = () =>{
        setTimerActive(false);
    }

    const requestVerificationCode = async () =>{
        await resendCode().then(res =>{
            setSendVerificationCode(true);
        })
    } 

    useEffect(() =>{
        if (sendVerificationCode == false) {
            requestVerificationCode();
        }
    },[])


    useEffect(() => {
        verCode && verCode.length == 4 ? submit() : true;
    },[verCode])

    const submit = async() =>{
        setIsLoading(true);
        setResetMultiInput(false);
        let data = user;
        setUser((prev) =>({
            ...prev,
            'verificationCode':verifycode.current
        }))
        data.verificationCode = verifycode.current;
        await validationAll().then(async re =>{
            
            const login = await signIn("credentials",data);
                    if (login.ok) { 
                        return router.push(user.callbackAddr);
                    }else{
                        setResetMultiInput(true);
                        setIsLoading(false);
                        Toaster(login.error);
                    }
        }).catch(e=>{
            Toaster("خطا های فرم را برطرف کنید");
            setIsLoading(false);
        })
    }


    const changeStepTo = (stepId) =>{
        setStep(stepId);
    }


    return (
        <div className="login-form steps active" id="step-2">
                        <div className="detail">
                            <h2>خوش آمدید !</h2>
                            <span className="alert w-100 d-block text-center alert-dark text-dark my-2"> کد یکبار مصرف برای شماره {user.Username} ارسال شد.</span>
                            <p className="mt-4">لطفا کد فعالسازی ارسال شده به شماره موبایل خود را در کادر زیر وارد نمایید.</p>
                        </div>
                        
                        <OtpInput onChengeValue={setMultiValue} reset={resetMultiInput}></OtpInput>

                        <div className="quick-access my-1 mt-3">
                        {
                            user.isRegister == 1 && (
                            <div className="link" onClick={() => changeStepTo(3)}>
                                <span>ورود با کلمه عبور؟</span>
                            </div>
                            )}
                            <div className="resend" id="resend-opt-base">
                                {timerActive && (
                                    <Timer second={120} timerOn={timerActive} finish={finishTimer}  />
                                )}

                                {!timerActive && (
                                                        <button className="btn btn-block border rounded bg-secondary p-2 text-info  w-100 f-15" onClick={resendCode}>
                                                        <span className="btn-text  text-center d-block f-12">
                                                            ارسال مجدد  
                                                        </span>
                                                            
                                                            
                                                        </button>
                                )}
                            </div>
                        </div>
                        <div className="submit-form">
                        <SubmitButton text={'ورود '} isDisabled={isLoading} isLoading={isLoading} callback={submit} />
                        </div>
                        
                        
                    </div>
    )
}

export default Verification;